﻿using Prism.Mvvm;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Windows;

namespace WpfApp16
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private Random rand;

        public MainWindow( )
        {
            InitializeComponent();

            this._dataGrid.DataSource = getDL1_list();
        }

        private List<DataLevel1> getDL1_list( )
        {
            rand = new Random();
            var dataL1 = new List<DataLevel1>();
            for ( var t = 0; t < rand.Next(520, 531); ++t )
            {
                dataL1.Add(createRandomL1());
            }

            return dataL1;
        }

        private DataLevel1 createRandomL1( )
        {
            var t = new DataLevel1
            {
                L1_col1 = randomString("c1-"),
                L1_col2 = randomString("c2-"),
                L1_col3 = randomString("c3-"),
                L1_col4 = randomString("c4-"),
                L2_items = new ObservableCollection<DataLevel2>(),
            };
            for ( var s = 0; s < rand.Next(1, 4); ++s )
            {
                var st = createRandomL2();
                t.L2_items.Add(st);
            }

            return t;
        }

        private DataLevel2 createRandomL2( )
        {
            var s = new DataLevel2
            {
                L2_col1 = randomString("s1-"),
                L2_col2 = randomString("s2-"),
            };

            return s;
        }

        private string randomString( string v, int len = 1 )
        {
            var randStr = string.Empty;
            for ( var i = 0; i < len; ++i )
                randStr += (char)('a' + rand.Next(25));
            return $"{v}{randStr}";
        }

        private void XamDataGrid_RecordExpanding(object sender, Infragistics.Windows.DataPresenter.Events.RecordExpandingEventArgs e)
        {
            if (e.Record.ParentRecord == null)
            {
                foreach (var item in e.Record.ViewableChildRecords)
                {
                    item.IsExpanded = true;
                }
            }
        }
    }

    public class ExtendedBindableBase : BindableBase
    {
        [Browsable(false)]
        public List<bool> CustomBoolList { get; set; }
    }

    public class DataLevel1 : ExtendedBindableBase
    {
        public string L1_col1 { get; set; }
        public string L1_col2 { get; set; }
        public string L1_col3 { get; set; }
        public string L1_col4 { get; set; }
        public ObservableCollection<DataLevel2> L2_items { get; set; }
        public DataLevel1( )
        {
        }
    }

    public class DataLevel2 : BindableBase
    {
        public string L2_col1 { get; set; }
        public string L2_col2 { get; set; }
        public DataLevel2( )
        {
        }
    }
}
